// --- Event Handler Functions --- //
// from: http://www.scottandrew.com/weblog/articles/cbs-events
function addEvent(obj, evType, fn, useCapture) {
	if (obj.addEventListener) {
		obj.addEventListener(evType, fn, useCapture);
		return true;
	}
	else if (obj.attachEvent) {
		var r = obj.attachEvent("on"+evType, fn);
		return r;
	}
	else
		alert("Handler could not be attached");
}

function removeEvent(obj, evType, fn, useCapture) {
	if (obj.removeEventListener) {
		obj.removeEventListener(evType, fn, useCapture);
		return true;
	}
	else if (obj.detachEvent) {
		var r = obj.detachEvent("on"+evType, fn);
		return r;
	}
	else
		alert("Handler could not be removed");
}


// --- other functions --- //
function include(uri) {
	// the HTML way cause the DOM way explodes!
	document.write('<script src="'+ uri +'" type="text/javascript"></script>');
}

function HTMLSpecialChars(str) {
	if (typeof str == 'string') {
		str = str.replace(/\</g,'&#060;');
		str = str.replace(/\>/g,'&#062;');
	}
	return str;
}

function print_r(array) {
	if (typeof array == 'object' && array[0]) {
		var str = '';
		for (var i=0; i<array.length; i++) {
			array[i] = print_r(array[i]);
			str += array[i];
			if (array[i+1]) str += ', ';
		}
		str = 'Array( '+ str +')';
		return HTMLSpecialChars(str);
	}
	return HTMLSpecialChars(array);
}

function randomInt(length) {
	if (!length) length = 4;
	return Math.round(Math.random() * Math.pow(10,length));
}

function randomString(length) {
	return randomInt(length).toString();
}

function $(id) {
	return document.getElementById(id);
}

function $tags(name) {
	return document.getElementsByTagName(name);
}

function $new(type, id) {
	var element = document.createElement(type);
	if (id) element.id = id;
	return element;
}

function $text(text) {
	return document.createTextNode(text);
}



// --- Get positon of element --- //
// from: http://www.quirksmode.org/js/findpos.html
function findPosX(obj) {
	var curleft = 0;
	if (obj.offsetParent) {
		while (obj.offsetParent) {
			curleft += obj.offsetLeft;
			obj = obj.offsetParent;
		}
	}
	else if (obj.x)
		curleft += obj.x;
	return curleft;
}

function findPosY(obj) {
	var curtop = 0;
	if (obj.offsetParent) {
		while (obj.offsetParent) {
			curtop += obj.offsetTop;
			obj = obj.offsetParent;
		}
	}
	else if (obj.y)
		curtop += obj.y;
	return curtop;
}